/* 
 * arp_internal.h
 *
 * x-kernel v3.1	12/10/90
 *
 * Copyright (C) 1990  Larry L. Peterson and Norman C. Hutchinson
 */

#define	ARP_HRD	  1
#define	ARP_PROT  0x0800	/* doing IP addresses only */
#define	ARP_HLEN  28		/* the body is null */
#define	ARP_TAB   100		/* arp table size */
#define ARP_TIME  2000		/* 2 seconds */
#define ARP_RTRY  2		/* retries for arp request */
#define ARP_RRTRY 200000	/* retries for rarp request */

#define	ARP_REQ   1
#define	ARP_RPLY  2
#define	ARP_RREQ  3
#define	ARP_RRPLY 4

#define	ARP_ARP   0
#define	ARP_RARP  1

typedef struct arppak {
  short  arp_hrd;
  short  arp_prot;
  char   arp_hlen;
  char   arp_plen;
  short  arp_op;
  ETHhost  arp_sha;
  IPhost arp_spa;
  ETHhost  arp_tha;
  IPhost arp_tpa;
} arppak;

typedef struct arpent {
  char   arp_state;
  ETHhost  arp_Ead;
  IPhost arp_Iad;
  Semaphore s;
} arpent;

#define	ARP_FREE  0
#define	ARP_ALLOC 1
#define	ARP_RSLVD 2

typedef struct arpstate {
  struct arppak req_msg;
  int 	 tries;
  int	 type;
  Sessn	 down_s;
  int	 pos;
} arpstate;


