/*
 * pmap0.c
 *
 * x-kernel v3.1	12/10/90
 *
 * Copyright (C) 1990  Larry L. Peterson and Norman C. Hutchinson
 */

#include <rpc/rpc.h>
#include "xkernel.h"
#include "ip.h"
#include "udp.h"
#include "sun_rpc.h"
#include "pmap.h"
#include "pmap_internal.h"

static XObj SELF=0;
#define SUNRPC SELF->down[0]
#define IP SELF->down[1]
#define PMAP0 SELF
static Msg null_msg={0,0};
static pmapproc_null();
int tracepmap0p=0;

static pmap0_instantiateprotl(self) 
XObj self;
{
  TRACE0(pmap0p, 1, "PMAP0 instanciateprotl");

  if (SELF) {
    Kabort("SUN Portmapper 0: can't instanciate twice");
  }
  SELF = self;
  return 0;
}


static pmap0_init(self)
XObj self;
{

  Part part[2];
  SUNRPCaddr server;
  IPhost myipaddr;

  port_map = map_create(100,12);
  if (x_controlprotl(IP, GETMYADDR, (char *)&myipaddr, sizeof myipaddr) < 0) {
    printf("Can't find my IP addr\n");
    return(-1);
  }

  server.prog = PMAP_PROG;
  server.vers = PMAP_VERS;
  server.proc = PMAPPROC_NULL;
  server.prot = 17;
  server.host.port = PMAP_PORT;  
  server.host.host = myipaddr;;

  init_partlist(part, 1, SUNRPCaddr); 
  set_part(part, 0, server);

  return (x_openenable(PMAP0, SUNRPC, part));;

}



static pmap0_demux(self,s, msg)
XObj 	self;
XObj	s;
Msg msg;
{
  char *buf;
  int len;
  char buf2[100];
  int len2;
  int hlp;
  PMAP_ARGS args;
  int *results;
  Msg msg2;
  

  /* externalize message */
  len = msg_len(msg);
  buf = (char *) malloc(len + 2);

  msg_externalize(msg,buf);


  /* check authentication */

  /* check authentication */


  /* decode arguments */
  /*
  if (decode_xdr(xdr_pmap,buf,len,&args) == -1) {;
    x_controlsessn(s,SVCGARBAGE_ARGS,0,0);
    return(-1);
  }
  is out cause is pmap1 code */ 

  /* call procedure */ 
/*
  results = pmapproc_set(&args);
 */
  pmapproc_null();
  

  /* xdr results */

/*
  if (results != 0) { 
    if ((len2 = encode_xdr(xdr_bool,buf2,100,results)) == -1) {;
      x_controlsessn(s,SVCGARBAGE_ARGS,0,0);
      free(results);
      return(-1);
    } else {
      free(results);
    }
  } else {
    x_controlsessn(s,SVCSYSTEM_ERR,0,0);
    return(-1);
  }
 */

  /* set authentication */

  IFTRACE(pmap0p,7) {
  printf("XXXXXXXXXXXXXXXXXX\n\nXXserver_demux: len2 = %d buf2 = %d\n",len2,buf2);
  print_xdr(buf2,len);
  }

  /* internalize message */
   msg_make_allstack(msg2,256,buf2,len2);
  
  /* reply to call */
  x_push(s,msg2,(Msg *)0);
  free(buf);
  return(0);
}


/*

static int *pmapproc_set(args)
PMAP_ARGS *args;
{
  PMAP_EXT_ID ext_id;
  int *reply;


  TRACE0(pmap0p,1,"pmap_set: entered\n");
  IFTRACE(pmap0p,1) print_pmap(args);
  ext_id.prog = args->prog;
  ext_id.vers = args->vers;
  ext_id.prot = args->prot;
  TRACE0(pmap0p,7,"pmap_set: args transfered\n");
  reply = (int *) malloc(sizeof(int));
  if (map_bind(port_map,&ext_id,args->port) == (Bind) -1 ) {
    TRACE0(pmap0p,3,"pmap_set: bind fails\n");
    *reply = 0;
    return(reply);
  }
  TRACE0(pmap0p,3,"pmap_set: bind succeeds\n");
  *reply = 1;
  return(reply);
}
*/

static pmap0_opendone(self,s,part)
XObj self;
XObj s;
Part part;
{
  TRACE0(pmap0p,7,"--->pmap0_opendone");
}
static pmapproc_null()
{
}

pmap0_getproc(p,type)
XObj p;
XObjType type;
{
  if (type == Protocol) {
    p->instantiateprotl = pmap0_instantiateprotl;
    p->init = pmap0_init;
  } else {
    p->instantiateprotl = noop;
    p->init = noop;
  }
  p->close = noop;
  p->control = noop;
  p->push = noop; 
  p->pop = noop;
  p->open = (Pfi) noop;
  p->openenable = noop;
  p->opendone = pmap0_opendone;
  p->closedone = noop;
  p->opendisable = noop;
  p->demux = pmap0_demux;
  p->getproc = pmap0_getproc;
}

