/* 
 * process.h
 *
 * x-kernel v3.1	12/10/90
 *
 * Copyright 1990  Larry L. Peterson and Norman C. Hutchinson
 */

#ifndef process_h
#define process_h

#ifndef NULL
#define NULL 0
#endif

#ifdef USE_GC
#define malloc(X) gc_malloc(X)
#define free(X) gc_free(X)
#endif

typedef struct {
#ifdef sun
  int pc, smask, onstack;
  int d2, d3, d4, d5, d6, d7;
  int a2, a3, a4, a5, a6;
  long *sp;
#endif
#ifdef vax
  long *pc, *sp, *fp, *ap;
  int r6, r7, r8, r9, r10, r11;
#endif
} jmp_buf;

typedef struct _Process {
  jmp_buf		jb;
  long 			*stack, *stacklimit;
  short			prio;
  struct _Process *	link;
  int			extrastuff;
  int			index;
} Process;
#define STACKSIZE (32*1024)

typedef struct sSemaphore {
  struct _Process		*head;
  struct _Process	       **tail;
  short				 unused;
  short				 count;
} Semaphore;
#define Q_INIT(Q) { \
  (Q)->head = NULL; \
  (Q)->tail = &(Q)->head; \
}

#define Q_EMPTY(Q) ((Q)->tail == &(Q)->head)

#define Q_INSERTLAST(Q, E) { \
  *((Q)->tail) = (E); \
  (E)->link = NULL; \
  (Q)->tail = &(E)->link; \
}

#define Q_INSERTFIRST(Q, E) { \
  (E)->link = (Q)->head; \
  (Q)->head = (E); \
  if (Q_EMPTY(Q)) (Q)->tail = &(E)->link; \
}

#define Q_REMOVEFIRST(Q, E) { \
  if ((E) = (Q)->head) { \
    if (! ((Q)->head = (E)->link)) (Q)->tail = &(Q)->head; \
  } \
}

#define P(S) { if (--(S)->count < 0) realP(S); }

#define V(S) { if (++(S)->count <= 0) realV(S); }

extern Process *Active;
extern int	SignalsPossible;
#define kSwitch() Yield()
#endif
